
#include <cstdlib>
#include <iostream>
#include "IceRink.h"
#include "CommonIceSkater.h"
#include "RookieIceSkater.h"
#include "ChildIceSkater.h"
#include "AdvancedIceSkater.h"

using namespace std;

IceRink::IceRink(int width, int length, int number, int time)
{
    M = width;
    L = length;
    N = number;
    T = time;
    
    createStage();
    
    createSkaters();
}

IceRink::~IceRink()
{ 
    //diagrafi pagodromon pou apomenoun
    for(int i = 0; i < M+1; i++)
    {
        for(int j = 0; j < L+1; j++)
        {
            if (stage[i][j] != NULL)
            {
                delete stage[i][j];
            }
        }
    }
    
    //apodesmeusi 2d pinaka
    for(int i = 0; i < M+1; i++)
    {
        delete[] stage[i];
    }
    
    delete[] stage;
}

void IceRink::createStage()
{
    //dinamiki desmeusi 2d pinaka 
    stage = new IceSkater**[M+1];
    
    for(int i = 0; i < M+1; i++)
    {
        stage[i] = new IceSkater*[L+1];
    }
    
    //arxikopoiisi pinaka
    for(int i = 0; i < M+1; i++)
    {
        for(int j = 0; j < L+1; j++)
        {
            stage[i][j] = NULL;
        }
    }
}
    
void IceRink::createSkaters()
{
    int li, col, sp, vd, hd, s, d;
    
    
    for(int i = 0; i < N; i++)
    {                  
        s = rand() % 4;
        switch (s)
        {
            case 0:
                vd = (M+1) * 0.3;
                hd = (L+1) * 0.3;  
                place(vd, hd, d, li, col);
                sp = (M <= L ? (rand() % M)+1 : (rand() % L)+1 );                     
                stage[li][col] = new CommonIceSkater(li, col, sp, vd, hd, d, NULL);
                break;
            case 1: 
                vd = (M+1) * 0.1;
                hd = (L+1) * 0.1;   
                place(vd, hd, d, li, col); 
                vd = (M+1) * 0.1;
                hd = (L+1) * 0.1; 
                stage[li][col] = new RookieIceSkater(li, col, vd, hd, d, NULL);
                break;
            case 2:               
                vd = (M+1) * 0.1;
                hd = (L+1) * 0.1;
                place(vd, hd, d, li, col); 
                vd = (M+1) * 0.1;
                hd = (L+1) * 0.1;                 
                stage[li][col] = new ChildIceSkater(li, col, vd, hd, d, NULL);
                break;
            default:                
                li = rand() % (M+1);
                col = rand() % (L+1);
                //elengxos an yparxei allos stin sygekrimeni thesi
                while(stage[li][col] != NULL)
                {
                    li = rand() % (M+1);
                    col = rand() % (L+1);      
                }    
                d = generateDirection(li, col);
                sp = (M <= L ? (rand() % M)+1 : (rand() % L)+1 );                
                stage[li][col] = new AdvancedIceSkater(li, col, sp, d, NULL);
        }   
    }
}   

void IceRink::place( int& vd, int& hd, int& d, int& li, int& col)
{
    if((rand() % 2) == 0)
    {
        col = rand() % (L+1);        

        if((rand() % 2) == 0)
        {
            if (col == L)
                d = 4;
            else
                d = 2;
            li = rand() % (vd+1);
            while(stage[li][col] != NULL)
            {
                li = rand() % (vd+1);
                col = rand() % (L+1);      
            }   
            vd = li;
        }
        else
        {
            if (col == 0)
                d = 0;
            else
                d = 6;
            li = M - rand() % (vd+1);
            while(stage[li][col] != NULL)
            {
                li = M - rand() % (vd+1);
                col = rand() % (L+1);      
            }                             
            vd = M - li;           
        }
        int temp = rand() % (hd+1);
        hd = (col < hd || L - col < hd ? (col < L - col? col : L - col): temp);         
    }
    else
    {
        li = rand() % (M+1);      
        
        if((rand() % 2) == 0)
        {
            if (li == 0)
                d = 2;
            else
                d = 0;
            col = rand() % (hd+1);
            while(stage[li][col] != NULL)
            {
                li = rand() % (M+1); 
                col = rand() % (hd+1);      
            } 
            hd = col;            
        }
        else
        {
            if (li == M)
                d = 6;
            else
                d = 4;
            col = L - rand() % (hd+1);
            while(stage[li][col] != NULL)
            {
                li = rand() % (M+1); 
                col = L - rand() % (hd+1);       
            }
            hd = L - col;             
        }
        int temp = rand() % (vd+1);
        vd = (li < vd || M - li < vd ? (li < M - li? li : M - li) : temp); 
    }     
}

int IceRink::generateDirection(int li, int col)
{
    int d;
    
    if(li > M/2 && col <= L/2)//vrisketai sto kato aristera tetartimorio
    {
        if(col == 0)
            d = 0;
        else if(li == M)
        {
            d = rand() % 3;
            if(d != 0)
                d = d + 5;
        }
        else
            do{
                d = rand() % 8;
            }while(d > 0 && d < 4);

    }

    else if(li <= M/2 && col <= L/2)//vrisketai sto pano aristera tetartimorio
    {
        if(li == 0)
            d = 2;
        else if(col == 0)
            d = rand() % 3;
        else
            do{
                d = rand() % 8;
            }while(d > 2 && d < 6);

    }               

    else if(li <= M/2 && col > L/2)//vrisketai sto pano deksia tetartimorio
    {
        if(col == L)
            d = 4;
        else if(li == 0)
        {
            d = (rand() % 3) + 2;
        }
        else
            do{
                d = rand() % 8;
            }while(d > 4);

    }

    else if(li > M/2 && col > L/2)//vrisketai sto kato deksia tetartimorio
    {
        if(li == M)
            d = 6;
        else if(col == L)
        {
            d = (rand() % 3) + 4;
        }
        else
            do{
                d = rand() % 8;
            }while(d > 6 && d < 2);

    }     
    
    return d;
}

void IceRink::simulate()
{  
    printStageInfo();     
    for(int t = 0; t < T; t++)
    {
        for(int i = 0; i < M+1; i++)
        {
            for(int j = 0; j < L+1; j++)
            {
                if (stage[i][j] != NULL && !stage[i][j]->hasMoved())
                {
                    stage[i][j]->skate(stage, M, L);
                }
            }
        }        
        printStageInfo(); 
        for(int i = 0; i < M+1; i++)
        {
            for(int j = 0; j < L+1; j++)
            {
                if (stage[i][j] != NULL)
                {
                    stage[i][j]->setMoved(false);
                    if(stage[i][j]->getTime() == 0)
                    {
                        delete stage[i][j];
                        stage[i][j] = NULL;
                    }                    
                }
            }
        }  
    }   
}

void IceRink::printStageInfo()
{
    for(int i = 0; i < M+1; i++)
    {
        for(int j = 0; j < L+1; j++)
        {
            if (stage[i][j] != NULL)
            {
                stage[i][j]->print();
            }                       
            else
            {
                cout << " * ";
            }
        }
        cout << endl;
    }
}